-- O
local setting
local outputDir, imageDir, isTrim, compressLevel
for line in io.lines("arguments.txt") do
    -- ݒ̓ǂݍ
    if not setting then
        setting = {}
        for key, value in string.gmatch(line, "([^\x09=]+)=([^\x09]*)") do
            setting[key] = value
        end
        -- ݒ̎擾
        outputDir = setting["outputDir"]
        imageDir = setting["imageDir"]
        isTrim = setting["isTrim"]
        compressLevel = tonumber(setting["compressLevel"])
    end
end
-- ݒt@C폜
local success, args = pcall(os.remove("arguments.txt"))

-- 摜
local list = getFileList(imageDir, "*.txt", 1)
local len = string.len(imageDir) + 1
local BLEND_ALPHA = 1
for i, path in pairs(list) do
    -- _info.txtǂݍ݁Al擾
    -- info.txt̍ڔԍ
    local INFO_DRESS_NAME = 2
    local INFO_DRESS_DIFF = 4
    local INFO_DRESS_IMAGE = 5
    local INFO_FACE_NAME = 2
    local INFO_FACE_IMAGE = 4
    -- "dress"e[u
    local dressInfo = {}
    local dressNum = {}
    -- info.txt̓ǂݍ
    local posFileHead, isInfo = string.match(getBaseName(path), "^(.+)_(info)$")
    local faceInfo = {}
    local faceNum = {}
    if isInfo then
        -- read info.txt
        for line in io.lines(path) do
            local type
            local dressName, name
            local count = 1
            for part in string.gmatch(line, "[^\t]+") do
                if not type then
                    type = part
                else
                    -- "dress"̕+ŉ摜O[v
                    if type == "dress" then
                        -- 
                        if count == INFO_DRESS_NAME then
                            dressName = part
                        -- 
                        elseif count == INFO_DRESS_DIFF then
                            name = dressName .. part
                        -- 摜
                        elseif count == INFO_DRESS_IMAGE then
                            part = string.match(part, "([^/]+)$")
                            if not dressInfo[name] then
                                dressInfo[name] = {dressName}
                            end
                            table.insert(dressInfo[name], part)
                            -- layer_idƉ摜ԍi[ϐ
                            dressNum[part] = -1
                        end
                    -- "face"摜̃O[v
                    elseif type == "face" then
                        -- \O[v
                        if count == INFO_FACE_NAME then
                            name = part
                            if not faceInfo[name] then
                                faceInfo[name] = {}
                            end
                        -- 摜
                        elseif count == INFO_FACE_IMAGE then
                            table.insert(faceInfo[name], part)
                            -- layer_idƉ摜ԍi[ϐ
                            faceNum[part] = -1
                        end
                    else
                        break
                    end
                end
                count = count + 1
            end
        end
        -- read info.txt end

        -- ݒt@Cǂݍ݁A摜
        -- ݒt@C̍ڔԍ
        local IMAGE_NAME = 2
        local IMAGE_LEFT = 3
        local IMAGE_TOP = 4
        local IMAGE_LAYER_ID = 10
        -- ݒt@C̓ǂݍ
        local posFileList = getFileList(imageDir, posFileHead .. "*.txt", 1)
        for j, posFilePath in pairs(posFileList) do
            local baseName = getBaseName(posFilePath)
            if baseName == posFileHead or
               baseName == posFileHead .. "_0" or -- w邢qxw邢qFDxɂ͊֌WȂ
               baseName == posFileHead .. "_1" or
               baseName == posFileHead .. "_2" then
                -- TutH_̎擾
                local subDir = getParentFolderName(string.sub(posFilePath, len))
                subDir = (subDir == "") and "\\" or subDir

                -- 摜̓ǂݍ
                local imageHead = getBaseName(posFilePath)
                local width, height
                local imageNum = 0
                for line in io.lines(posFilePath) do
                    local count = 1
                    local name
                    local left, top
                    for part in string.gmatch(line, "[^\t]+") do
                        -- 摜
                        if not width then
                            width = tonumber(part)
                            -- lϊłȂꍇ(1s)
                            if not width then
                                break
                            end
                        -- 摜c
                        elseif not height then
                            height = tonumber(part)
                            break
                        -- 摜
                        else
                            -- 摜
                            if count == IMAGE_NAME then
                                name = part
                            -- XW
                            elseif count == IMAGE_LEFT then
                                left = tonumber(part)
                            -- YW
                            elseif count == IMAGE_TOP then
                                top = tonumber(part)
                            -- C[ID
                            elseif count == IMAGE_LAYER_ID then
                                -- infoɒ`Ă摜Ȃǂݍ
                                local isLoadImage
                                -- \摜
                                if faceNum[name] then
                                    isLoadImage = "face"
                                -- 摜
                                elseif dressNum[name] then
                                    isLoadImage = "dress"
                                -- ̕ɂ̂ݎgp\摜
                                else
                                    for pos, dressList in pairs(dressInfo) do
                                        if faceNum[name .. "@" .. dressList[1]] then
                                            name = name .. "@" .. dressList[1]
                                            isLoadImage = "face"
                                            break
                                        end
                                    end
                                end
                                if isLoadImage then
                                    -- 摜t@C̑ݔ
                                    local loadImagePath = imageDir .. subDir .. imageHead .. "_" .. part
                                    local isImageFile = existFile(loadImagePath .. ".tlg")
                                    if isImageFile == 0 then
                                        isImageFile = existFile(loadImagePath .. ".png")
                                        loadImagePath = loadImagePath .. ".png"
                                    else
                                        loadImagePath = loadImagePath .. ".tlg"
                                    end
                                    -- 摜t@CΓǂݍ
                                    if isImageFile == 1 then
                                        imageNum = imageNum + 1
                                        -- layer_idƉ摜ԍ
                                        if isLoadImage == "dress" then
                                            dressNum[name] = {part, imageNum}
                                        else
                                            faceNum[name] = {part, imageNum}
                                        end
                                        -- 摜̓ǂݍ
                                        createImage(imageNum, width, height, 0x000000ff)
                                        loadImage(0, loadImagePath)
                                        blendImage(imageNum, 0, BLEND_ALPHA, left, top)
                                    end
                                end
                            end
                        end
                        count = count + 1
                    end
                end

                -- 摜(dressCAfaceO[vAdressO[v̎c̏)
                for posList, dressList in pairs(dressInfo) do
                    local dressType
                    for faceGroupName, faceList in pairs(faceInfo) do
                        freeImage(0)
                        local faceLayerId = ""
                        local isFace = false
                        -- 摜̍
                        local saveImageBasePath = outputDir .. subDir .. imageHead
                        for posDress, dressName in ipairs(dressList) do
                            if not dressType then
                                dressType = dressName
                            else
                                if dressNum[dressName] and dressNum[dressName] ~= -1 then
                                    local dressLayerId = dressNum[dressName][1]
                                    local dressImgNum = dressNum[dressName][2]
                                    if dressImgNum and dressImgNum > 0 then
                                        if existImage(0) == 0 then
                                            -- dressC
                                            copyImage(0, dressImgNum)
                                            -- \̍
                                            for posFace, faceName in ipairs(faceList) do
                                                if faceNum[faceName] and faceNum[faceName] ~= -1 then
                                                    -- u\@ߑv̏ꍇÄߑ̂ݕ\
                                                    local specificDressType = string.match(faceName, "@(.+)$")
                                                    if not specificDressType or specificDressType == dressType then
                                                        local faceImgNum = faceNum[faceName][2]
                                                        if faceImgNum and faceImgNum > 0 then
                                                            faceLayerId = faceLayerId .. "_" .. faceNum[faceName][1]
                                                            blendImage(0, faceImgNum, BLEND_ALPHA, 0, 0)
                                                            isFace = true
                                                        end
                                                    end
                                                end
                                            end
                                        else
                                            -- dress
                                            blendImage(0, dressImgNum, BLEND_ALPHA, 0, 0)
                                        end
                                        saveImageBasePath = saveImageBasePath .. "_" .. dressLayerId
                                    end
                                end
                            end
                        end
                        -- o
                        if  existImage(0) == 1 and isFace then
                            if isTrim == "1" then
                                trimmingImage(0, "UDLR")
                            end
                            local saveImagePath = saveImageBasePath .. faceLayerId .. ".png"
                            saveImage(0, saveImagePath, 1, 0, compressLevel)
                            print("output: " .. saveImagePath .. "\n")
                        end
                    end
                end
                -- 摜J
                for num = 0, imageNum do
                    freeImage(num)
                end
            end
        end
    end
end
